<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>angular-frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	   <link rel="stylesheet" href="../styles/style.css">
        <link rel="stylesheet" href="../styles/dark.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">angular-frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content component">
                   <div class="content-data">




<ol class="breadcrumb">
  <li>Components</li>
  <li
  >
  CProjectsTableComponent</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
        <li >
            <a href="#templateData" role="tab" id="templateData-tab" data-toggle="tab" data-link="template">Template</a>
        </li>
        <li >
            <a href="#styleData" role="tab" id="styleData-tab" data-toggle="tab" data-link="style">Styles</a>
        </li>
        <li >
            <a href="#tree" role="tab" id="tree-tab" data-toggle="tab" data-link="dom-tree">DOM Tree</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info"><p class="comment">
    <h3>File</h3>
</p>
<p class="comment">
    <code>projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts</code>
</p>




    <p class="comment">
        <h3>Implements</h3>
    </p>
    <p class="comment">
                    <code><a href="https://angular.io/api/core/OnInit" target="_blank" >OnInit</a></code>
                    <code><a href="https://angular.io/api/core/AfterViewInit" target="_blank" >AfterViewInit</a></code>
    </p>


<section>
    <h3>Metadata</h3>
    <table class="table table-sm table-hover metadata">
        <tbody>











            <tr>
                <td class="col-md-3">selector</td>
                <td class="col-md-9"><code>app-c-projects-table</code></td>
            </tr>

            <tr>
                <td class="col-md-3">styleUrls</td>
                <td class="col-md-9"><code>./c-projects-table.component.css</code></td>
            </tr>



            <tr>
                <td class="col-md-3">templateUrl</td>
                <td class="col-md-9"><code>./c-projects-table.component.html</code></td>
            </tr>








        </tbody>
    </table>
</section>

    <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#dataSource" >dataSource</a>
                            </li>
                            <li>
                                <a href="#displayedColumns" >displayedColumns</a>
                            </li>
                            <li>
                                <a href="#input" >input</a>
                            </li>
                            <li>
                                <a href="#length" >length</a>
                            </li>
                            <li>
                                <a href="#pageIndex" >pageIndex</a>
                            </li>
                            <li>
                                <a href="#pageSize" >pageSize</a>
                            </li>
                            <li>
                                <a href="#pageSizeOptions" >pageSizeOptions</a>
                            </li>
                            <li>
                                <a href="#paginator" >paginator</a>
                            </li>
                            <li>
                                <a href="#project" >project</a>
                            </li>
                            <li>
                                <a href="#sort" >sort</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#getProject" >getProject</a>
                            </li>
                            <li>
                                <a href="#loadProjectsPage" >loadProjectsPage</a>
                            </li>
                            <li>
                                <a href="#ngAfterViewInit" >ngAfterViewInit</a>
                            </li>
                            <li>
                                <a href="#ngOnInit" >ngOnInit</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

    <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(projectAppService: <a href="../injectables/ProjectAppService.html" target="_self">ProjectAppService</a>, messageService: <a href="../injectables/MessageService.html" target="_self">MessageService</a>, route: <a href="https://angular.io/api/router/ActivatedRoute" target="_blank">ActivatedRoute</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="34" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:34</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>projectAppService</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/ProjectAppService.html" target="_self" >ProjectAppService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>messageService</td>
                                                  
                                                        <td>
                                                                        <code><a href="../injectables/MessageService.html" target="_self" >MessageService</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>route</td>
                                                  
                                                        <td>
                                                                        <code><a href="https://angular.io/api/router/ActivatedRoute" target="_blank" >ActivatedRoute</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>





    <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getProject"></a>
                    <span class="name">
                        <span ><b>getProject</b></span>
                        <a href="#getProject"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>getProject(row: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="89"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:89</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Default value</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>row</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>

                                    <td>
                                        <code>&#x27;&#x27;</code>
                                    </td>

                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        
                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="loadProjectsPage"></a>
                    <span class="name">
                        <span ><b>loadProjectsPage</b></span>
                        <a href="#loadProjectsPage"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>loadProjectsPage()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="78"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:78</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="ngAfterViewInit"></a>
                    <span class="name">
                        <span ><b>ngAfterViewInit</b></span>
                        <a href="#ngAfterViewInit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>ngAfterViewInit()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="52"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:52</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="ngOnInit"></a>
                    <span class="name">
                        <span ><b>ngOnInit</b></span>
                        <a href="#ngOnInit"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
<code>ngOnInit()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="42"
                            class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:42</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>
    <section>
    
    <h3 id="inputs">
        Properties
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="dataSource"></a>
                    <span class="name">
                        <span ><b>dataSource</b></span>
                        <a href="#dataSource"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="../interfaces/Project.html" target="_self" >ProjectsDataSource</a></code>

                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="22" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:22</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="displayedColumns"></a>
                    <span class="name">
                        <span ><b>displayedColumns</b></span>
                        <a href="#displayedColumns"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>    <code>[]</code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>[&quot;id&quot;, &quot;title&quot;, &quot;status&quot;, &quot;description&quot;]</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="25" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:25</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="input"></a>
                    <span class="name">
                        <span ><b>input</b></span>
                        <a href="#input"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="https://angular.io/api/core/ElementRef" target="_blank" >ElementRef</a></code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <b>Decorators : </b>
                        <br />
                        <code>
                            @ViewChild(&#x27;input&#x27;)<br />
                        </code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="34" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:34</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="length"></a>
                    <span class="name">
                        <span ><b>length</b></span>
                        <a href="#length"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="29" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:29</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="pageIndex"></a>
                    <span class="name">
                        <span ><b>pageIndex</b></span>
                        <a href="#pageIndex"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="27" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:27</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="pageSize"></a>
                    <span class="name">
                        <span ><b>pageSize</b></span>
                        <a href="#pageSize"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/number" target="_blank" >number</a></code>

                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="28" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:28</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="pageSizeOptions"></a>
                    <span class="name">
                        <span ><b>pageSizeOptions</b></span>
                        <a href="#pageSizeOptions"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>    <code>[]</code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Default value : </i><code>[3, 5, 10, 100]</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="26" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:26</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="paginator"></a>
                    <span class="name">
                        <span ><b>paginator</b></span>
                        <a href="#paginator"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>    <code>MatPaginator</code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <b>Decorators : </b>
                        <br />
                        <code>
                            @ViewChild(MatPaginator, {static: false})<br />
                        </code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="32" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:32</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="project"></a>
                    <span class="name">
                        <span ><b>project</b></span>
                        <a href="#project"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>        <code><a href="../interfaces/Project.html" target="_self" >Project[]</a></code>

                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="21" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:21</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="sort"></a>
                    <span class="name">
                        <span ><b>sort</b></span>
                        <a href="#sort"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
                <tr>
                    <td class="col-md-4">
                        <i>Type : </i>    <code>MatSort</code>

                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <b>Decorators : </b>
                        <br />
                        <code>
                            @ViewChild(MatSort)<br />
                        </code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="33" class="link-to-prism">projects/projects-app-ang/src/app/p-project-overview/c-projects-table/c-projects-table.component.ts:33</a></div>
                        </td>
                    </tr>


        </tbody>
    </table>
</section>

</div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnInit, ViewChild, AfterViewInit, ElementRef } from &#x27;@angular/core&#x27;;
import { CollectionViewer, DataSource} from &quot;@angular/cdk/collections&quot;;
import { ActivatedRoute } from &#x27;@angular/router&#x27;;
import { MatPaginator } from &#x27;@angular/material/paginator&#x27;;

import { BehaviorSubject, Observable, of, merge, fromEvent  } from &#x27;rxjs&#x27;;
import { catchError, finalize, tap, debounceTime, distinctUntilChanged  } from &#x27;rxjs/operators&#x27;;

import { ProjectAppService } from &#x27;../../services/project-app.service&#x27;;
import { Project } from &#x27;../../Project&#x27;;
import { MessageService } from &#x27;../../message.service&#x27;;
import { MatSort } from &#x27;@angular/material/sort&#x27;;

@Component({
  selector: &#x27;app-c-projects-table&#x27;,
  templateUrl: &#x27;./c-projects-table.component.html&#x27;,
  styleUrls: [&#x27;./c-projects-table.component.css&#x27;],
})
export class CProjectsTableComponent implements OnInit, AfterViewInit {

  project!: Project[];
  dataSource!: ProjectsDataSource;

  // Paginator
  displayedColumns&#x3D; [&quot;id&quot;, &quot;title&quot;, &quot;status&quot;, &quot;description&quot;];
  pageSizeOptions &#x3D; [3, 5, 10, 100];
  pageIndex:number;
  pageSize:number;
  length:number;


  @ViewChild(MatPaginator, {static:false}) paginator!: MatPaginator;
  @ViewChild(MatSort) sort!: MatSort;
  @ViewChild(&#x27;input&#x27;) input!: ElementRef;

  constructor(
      private projectAppService: ProjectAppService, 
      private messageService: MessageService,
      private route: ActivatedRoute
    ) {}

  ngOnInit() {
      this.project &#x3D; this.route.snapshot.data[&quot;project&quot;]
      this.dataSource &#x3D; new ProjectsDataSource(this.projectAppService,this.messageService);
      //this.dataSource.paginator &#x3D; this.paginator;
      //this.dataSource.getAllProjects()
      this.dataSource.loadProjects(&#x27;&#x27;, &#x27;asc&#x27;, 0, 3)
      console.log(&quot;ngOnInit()&quot;)
      console.log(this.dataSource)
  }

  ngAfterViewInit(): void {


      // server-side search
      fromEvent(this.input.nativeElement,&#x27;keyup&#x27;)
      .pipe(
          debounceTime(150),
          distinctUntilChanged(),
          tap(() &#x3D;&gt; {
              this.paginator.pageIndex &#x3D; 0;
              this.loadProjectsPage();
          })
      )
      .subscribe();

      // reset the paginator after sorting
      this.sort.sortChange.subscribe(() &#x3D;&gt; this.paginator.pageIndex &#x3D; 0);

      // on sort or paginate events, load a new page
      merge(this.sort.sortChange ,this.paginator.page)
          .pipe(
              tap(() &#x3D;&gt; this.loadProjectsPage())
          )
          .subscribe();
  }

  loadProjectsPage() {
      //this.dataSource.getAllProjects()
      
      this.dataSource.loadProjects(
          this.input.nativeElement.value,
          this.sort.direction,
          this.paginator.pageIndex,
          this.paginator.pageSize
      );
  }

  getProject(
    row&#x3D;&#x27;&#x27;
    ) {
      console.log(&quot;getProject&quot;)
      console.log(row)
  }

  

}

export class ProjectsDataSource implements DataSource&lt;Project&gt;{

  private projectsSubject &#x3D; new BehaviorSubject&lt;Project[]&gt;([]); 
  private loadingSubject &#x3D; new BehaviorSubject&lt;boolean&gt;(false);
  projects: Project[]&#x3D;[];

  public loading$ &#x3D; this.loadingSubject.asObservable();

  constructor(
    private projectService: ProjectAppService, 
    private messageService: MessageService
  ) {}

  connect(collectionViewer: CollectionViewer): Observable&lt;Project[]&gt; {
    return this.projectsSubject.asObservable();
  }

  disconnect(collectionViewer: CollectionViewer): void {
    this.projectsSubject.complete();
    this.loadingSubject.complete();
  }


  loadProjects(
      filter &#x3D; &#x27;&#x27;,
      sortDirection &#x3D; &#x27;asc&#x27;, 
      pageIndex &#x3D; 0, 
      pageSize: number
      ) {
    this.loadingSubject.next(true);

    this.projectService.findProjects(
          filter, 
          sortDirection,
          pageIndex, 
          pageSize
        ).pipe(
            catchError(
              error &#x3D;&gt; {
                this.log(&quot;Caught in CatchError. Returning []&quot;);
                console.log(&quot;loadProjects.pipe&quot;);
                return of([])
              }
              //() &#x3D;&gt; of([])
            ),
            finalize(() &#x3D;&gt; this.loadingSubject.next(false)),
            tap(_ &#x3D;&gt; this.log(&#x60;projects-material-table.components.ts: finalize&#x60;)),
        )
        .subscribe(
            project &#x3D;&gt; this.projectsSubject.next(project),
    );
  }  

  getAllProjects(): void {
    this.projectService.getAll()
    .subscribe(project &#x3D;&gt; this.projectsSubject.next(project));
  }

  /** Log a MessageService message with the MessageService */
  private log(message: string) {
    this.messageService.add(&#x60;MessageService: ${message}&#x60;);
  }
}</code></pre>
    </div>

    <div class="tab-pane fade " id="c-templateData">
        <pre class="line-numbers"><code class="language-html">&lt;nb-card&gt;
  &lt;nb-card-body&gt;

      &lt;div class&#x3D;&quot;mat-elevation-z8&quot;&gt;

          &lt;!-- This is the search box --&gt;
          &lt;mat-form-field&gt;
              &lt;input matInput placeholder&#x3D;&quot;Search projects by title&quot; #input&gt;
          &lt;/mat-form-field&gt;

          &lt;!-- This is a loading symbol --&gt;   
          &lt;div class&#x3D;&quot;spinner-container&quot; *ngIf&#x3D;&quot;dataSource.loading$ | async&quot;&gt;
              &lt;mat-spinner&gt;&lt;/mat-spinner&gt;
          &lt;/div&gt;

          &lt;!-- This is the table --&gt;
          &lt;mat-table 
              class&#x3D;&quot;projects-table mat-elevation-z8&quot; 
              [dataSource]&#x3D;&quot;dataSource&quot;
              matSort matSortActive&#x3D;&quot;id&quot; 
              matSortDirection&#x3D;&quot;asc&quot; 
              matSortDisableClear&gt;

              &lt;!--displayedColumns &#x3D; [&quot;id&quot;, &quot;status&quot;, &quot;description&quot;];--&gt;

              &lt;ng-container matColumnDef&#x3D;&quot;id&quot;&gt;
                  &lt;mat-header-cell *matHeaderCellDef mat-sort-header&gt;ID&lt;/mat-header-cell&gt;
                  &lt;mat-cell *matCellDef&#x3D;&quot;let project&quot;&gt;{{project.id}}&lt;/mat-cell&gt;
                  &lt;!--&lt;mat-cell class&#x3D;&quot;id-cell&quot; *matCellDef&#x3D;&quot;let project&quot;&gt;{{project.id}}&lt;/mat-cell&gt;--&gt;
              &lt;/ng-container&gt;

              &lt;ng-container matColumnDef&#x3D;&quot;title&quot;&gt;
                  &lt;mat-header-cell *matHeaderCellDef mat-sort-header&gt;Title&lt;/mat-header-cell&gt;
                  &lt;mat-cell *matCellDef&#x3D;&quot;let project&quot;&gt;{{project.title}}&lt;/mat-cell&gt;
                  &lt;!--&lt;mat-cell class&#x3D;&quot;id-cell&quot; *matCellDef&#x3D;&quot;let project&quot;&gt;{{project.id}}&lt;/mat-cell&gt;--&gt;
              &lt;/ng-container&gt;

              &lt;ng-container matColumnDef&#x3D;&quot;status&quot;&gt;
                  &lt;mat-header-cell *matHeaderCellDef&gt;Status&lt;/mat-header-cell&gt;
                  &lt;mat-cell class&#x3D;&quot;status-cell&quot; *matCellDef&#x3D;&quot;let project&quot;&gt;{{project.status}}&lt;/mat-cell&gt;
              &lt;/ng-container&gt;

              &lt;ng-container matColumnDef&#x3D;&quot;description&quot;&gt;
                  &lt;mat-header-cell *matHeaderCellDef&gt;Description&lt;/mat-header-cell&gt;
                  &lt;mat-cell class&#x3D;&quot;description-cell&quot; *matCellDef&#x3D;&quot;let project&quot;&gt;{{project.description}}&lt;/mat-cell&gt;
              &lt;/ng-container&gt;

              &lt;mat-header-row *matHeaderRowDef&#x3D;&quot;displayedColumns&quot;&gt;&lt;/mat-header-row&gt;

              &lt;mat-row *matRowDef&#x3D;&quot;let row; columns: displayedColumns&quot; (click)&#x3D;&quot;getProject(row)&quot;&gt;&lt;/mat-row&gt;
      

          &lt;/mat-table&gt;


      &lt;/div&gt;
  &lt;/nb-card-body&gt;
&lt;/nb-card&gt;
</code></pre>
    </div>

    <div class="tab-pane fade " id="c-styleData">
                <p class="comment">
                    <code>./c-projects-table.component.css</code>
                </p>
                <pre class="line-numbers"><code class="language-scss"></code></pre>
    </div>

    <div class="tab-pane fade " id="c-tree">
        <div id="tree-container"></div>
        <div class="tree-legend">
            <div class="title">
                <b>Legend</b>
            </div>
            <div>
                <div class="color htmlelement"></div><span>Html element</span>
            </div>
            <div>
                <div class="color component"></div><span>Component</span>
            </div>
            <div>
                <div class="color directive"></div><span>Html element with directive</span>
            </div>
        </div>
    </div>

    
</div>

<script src="../js/libs/vis.min.js"></script>
<script src="../js/libs/htmlparser.js"></script>
<script src="../js/libs/deep-iterator.js"></script>
<script>
        var COMPONENT_TEMPLATE = '<div><nb-card>  <nb-card-body>      <div class="mat-elevation-z8">          <!-- This is the search box -->          <mat-form-field>              <input matInput placeholder="Search projects by title" #input>          </mat-form-field>          <!-- This is a loading symbol -->             <div class="spinner-container" *ngIf="dataSource.loading$ | async">              <mat-spinner></mat-spinner>          </div>          <!-- This is the table -->          <mat-table               class="projects-table mat-elevation-z8"               [dataSource]="dataSource"              matSort matSortActive="id"               matSortDirection="asc"               matSortDisableClear>              <!--displayedColumns = ["id", "status", "description"];-->              <ng-container matColumnDef="id">                  <mat-header-cell *matHeaderCellDef mat-sort-header>ID</mat-header-cell>                  <mat-cell *matCellDef="let project">{{project.id}}</mat-cell>                  <!--<mat-cell class="id-cell" *matCellDef="let project">{{project.id}}</mat-cell>-->              </ng-container>              <ng-container matColumnDef="title">                  <mat-header-cell *matHeaderCellDef mat-sort-header>Title</mat-header-cell>                  <mat-cell *matCellDef="let project">{{project.title}}</mat-cell>                  <!--<mat-cell class="id-cell" *matCellDef="let project">{{project.id}}</mat-cell>-->              </ng-container>              <ng-container matColumnDef="status">                  <mat-header-cell *matHeaderCellDef>Status</mat-header-cell>                  <mat-cell class="status-cell" *matCellDef="let project">{{project.status}}</mat-cell>              </ng-container>              <ng-container matColumnDef="description">                  <mat-header-cell *matHeaderCellDef>Description</mat-header-cell>                  <mat-cell class="description-cell" *matCellDef="let project">{{project.description}}</mat-cell>              </ng-container>              <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>              <mat-row *matRowDef="let row; columns: displayedColumns" (click)="getProject(row)"></mat-row>                </mat-table>      </div>  </nb-card-body></nb-card></div>'
    var COMPONENTS = [{'name': 'AddProjectComponent', 'selector': 'app-add-project'},{'name': 'AppComponent', 'selector': 'app-root'},{'name': 'AuthComponent', 'selector': 'app-auth'},{'name': 'CAbschlussComponent', 'selector': 'app-c-abschluss'},{'name': 'CAccountComponent', 'selector': 'app-c-account'},{'name': 'CAnalyseComponent', 'selector': 'app-c-analyse'},{'name': 'CArchivierungComponent', 'selector': 'app-c-archivierung'},{'name': 'CBarComponent', 'selector': 'app-c-bar'},{'name': 'CDurchfuehrungComponent', 'selector': 'app-c-durchfuehrung'},{'name': 'CErhebungComponent', 'selector': 'app-c-erhebung'},{'name': 'CExitComponent', 'selector': 'app-c-exit'},{'name': 'CHomeComponent', 'selector': 'app-c-home'},{'name': 'CLandingComponent', 'selector': 'app-c-landing'},{'name': 'CLanguageComponent', 'selector': 'app-c-language'},{'name': 'CNachzutzungComponent', 'selector': 'app-c-nachzutzung'},{'name': 'CPlanungComponent', 'selector': 'app-c-planung'},{'name': 'CProjectsTableComponent', 'selector': 'app-c-projects-table'},{'name': 'CVorbereitungComponent', 'selector': 'app-c-vorbereitung'},{'name': 'CZugangComponent', 'selector': 'app-c-zugang'},{'name': 'LandingComponent', 'selector': 'app-landing'},{'name': 'LogoutComponent', 'selector': 'app-logout'},{'name': 'MainComponent', 'selector': 'app-main'},{'name': 'MessagesComponent', 'selector': 'app-messages'},{'name': 'MHeaderComponent', 'selector': 'app-m-header'},{'name': 'MyProjectComponent', 'selector': 'app-my-project'},{'name': 'NgxLoginComponent', 'selector': 'ngx-login'},{'name': 'ProjectDetailsComponent', 'selector': 'app-project-details'},{'name': 'ProjectsListComponent', 'selector': 'app-projects-list'},{'name': 'ProjectsMaterialTableComponent', 'selector': 'app-projects-material-table'},{'name': 'RegisterComponent', 'selector': 'app-register'},{'name': 'RequestPasswordComponent', 'selector': 'app-request-password'},{'name': 'ResetPasswordComponent', 'selector': 'app-reset-password'}];
    var DIRECTIVES = [];
    var ACTUAL_COMPONENT = {'name': 'CProjectsTableComponent'};
</script>
<script src="../js/tree.js"></script>

















                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

          <label class="dark-mode-switch">
               <input type="checkbox">
               <span class="slider">
                    <svg class="slider-icon" viewBox="0 0 24 24" fill="none" height="20" stroke="#000" stroke-linecap="round" stroke-linejoin="round" stroke-width="2" width="20" xmlns="http://www.w3.org/2000/svg">
                    <path d="M21 12.79A9 9 0 1111.21 3 7 7 0 0021 12.79z"></path>
                    </svg>
               </span>
          </label>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'component';
            var COMPODOC_CURRENT_PAGE_URL = 'CProjectsTableComponent.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>

       <script src="../js/menu-wc.js" defer></script>
       <script nomodule src="../js/menu-wc_es5.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
